#include "PsfTest.h"

START

TEST(Psf, General) {
  DoubleImage *_di = null;
  PsfEntry *entry;
  Psf *_psf = null;

  double_image_new_y(&_di, 10, 15);
  _di->y[6][8] = 1;
  _di->y[6][7] = 2;
  _di->y[7][6] = 3;
  _di->y[8][5] = 4;
  psf_new(&_psf, _di);
  double_image_delete(&_di);
  EXPECT_ULEQ(4, _psf->numEntries);
  entry = &_psf->_entries[0];
  EXPECT_LEQ(-1, entry->i);
  EXPECT_LEQ(1, entry->j);
  EXPECT_NEAR(0.2, entry->w, 1e-15);
  entry = &_psf->_entries[1];
  EXPECT_LEQ(-1, entry->i);
  EXPECT_LEQ(2, entry->j);
  EXPECT_NEAR(0.1, entry->w, 1e-15);
  entry = &_psf->_entries[2];
  EXPECT_LEQ(0, entry->i);
  EXPECT_LEQ(0, entry->j);
  EXPECT_NEAR(0.3, entry->w, 1e-15);
  entry = &_psf->_entries[3];
  EXPECT_LEQ(1, entry->i);
  EXPECT_LEQ(-1, entry->j);
  EXPECT_NEAR(0.4, entry->w, 1e-15);
  psf_delete(&_psf);
}

FINISH
